unit UMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Grids, StdCtrls, Unitstatus;

type
  (* Datentyp fuer die virtuelle Welt*)


  { TfrmMain }

  TfrmMain = class(TForm)
    btnZufall: TButton;
    btnNext: TButton;
    btnStart: TButton;
    btnStopp: TButton;
    btnLeer: TButton;
    Spielfeld: TDrawGrid;
    pnlBottom: TPanel;
    tmrAnimation: TTimer;
    procedure btnLeerClick(Sender: TObject);
    procedure Auswerten(Sender: TObject);
    procedure btnStoppClick(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnZufallClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SpielfeldDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure SpielfeldSelectCell(Sender: TObject; aCol, aRow: Integer;
      var CanSelect: Boolean);
  private
    { private declarations }

    (* virtuelle Spielwelt *)


  public
    { public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.lfm}

{ TfrmMain }

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  aufbau;
  FillByte (a,SizeOf(a),0);
  FillByte (b,SizeOf(b),0);
end;







procedure TfrmMain.SpielfeldDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
  var i:s;
begin

    i:= a[aCol+1, aRow+1];

    case i of
        0: Spielfeld.Canvas.Brush.Color := clBlack;
        1: Spielfeld.Canvas.Brush.Color := clMaroon;
        2: Spielfeld.Canvas.Brush.Color := clGreen;
        3: Spielfeld.Canvas.Brush.Color := clOlive;
        4: Spielfeld.Canvas.Brush.Color := clNavy;
        5: Spielfeld.Canvas.Brush.Color := clPurple;
        6: Spielfeld.Canvas.Brush.Color := clTeal;
        7: Spielfeld.Canvas.Brush.Color := clRed;
        8: Spielfeld.Canvas.Brush.Color := clLime;
        9: Spielfeld.Canvas.Brush.Color := clYellow;
       10: Spielfeld.Canvas.Brush.Color := clBlue;
       11: Spielfeld.Canvas.Brush.Color := clFuchsia;
       12: Spielfeld.Canvas.Brush.Color := clAqua;
       13: Spielfeld.Canvas.Brush.Color := clMoneyGreen;
       14: Spielfeld.Canvas.Brush.Color := clSkyBlue;
       15: Spielfeld.Canvas.Brush.Color := clCream;
     end;


 Spielfeld.Canvas.FillRect(aRect);
end;

procedure TfrmMain.SpielfeldSelectCell(Sender: TObject; aCol, aRow: Integer;
  var CanSelect: Boolean);

begin


    a[aCol+1, aRow+1]:=7;
end;




procedure TfrmMain.btnLeerClick(Sender: TObject);
begin
  FillByte (a,SizeOf(a),0);
  FillByte (b,SizeOf(b),0);
  Spielfeld.Repaint;
end;

procedure TfrmMain.Auswerten(Sender: TObject);

begin

    spiel(a,b);
    Spielfeld.Refresh;
    a:= b;
end;

procedure TfrmMain.btnStoppClick(Sender: TObject);
begin
  tmrAnimation.Enabled := false;
  a:=b;
  Spielfeld.Refresh;
end;

procedure TfrmMain.btnStartClick(Sender: TObject);
begin
  tmrAnimation.Enabled := true;
end;

procedure TfrmMain.btnZufallClick(Sender: TObject);
begin
  zufall(a);
  Spielfeld.Repaint;
end;

procedure TfrmMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  tmrAnimation.Enabled := false;
  x := xa;
 abbaux(x);
 y := ya;
 abbauy(y);
end;

end.

